; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive
  
;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      include \masm32\include\dialogs.inc

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
      hiDlg   PROTO :DWORD,:DWORD,:DWORD,:DWORD
 
    .data?
      hWnd      dd ?
      hInstance dd ?

    .code

; 

start:
  
      mov hInstance, FUNC(GetModuleHandle,NULL)

      call main

      invoke ExitProcess,eax

; 

main proc

    invoke DialogBoxParam,hInstance,1000,0,ADDR DlgProc,NULL

    ret

main endp

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
 
    Switch uMsg
      Case WM_INITDIALOG
        invoke SendMessage,hWin,WM_SETICON,1,
                           FUNC(LoadIcon,hInstance,200)
        m2m hWnd, hWin
        return 1
      Case WM_COMMAND
        Switch wParam
          Case 100
            invoke DialogBoxParam,hInstance,1001,0,ADDR hiDlg,NULL

          Case 101
            jmp quit_dialog
        EndSw
      Case WM_CLOSE
        quit_dialog:
        invoke EndDialog,hWin,0
    EndSw

    return 0

DlgProc endp

; 

hiDlg proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    Switch uMsg
      Case WM_INITDIALOG
        invoke SendMessage,hWin,WM_SETICON,1,
                           FUNC(LoadIcon,hInstance,200)
        m2m hWnd, hWin
        return 1
      Case WM_COMMAND
        Switch wParam
          Case 100
            jmp quit_dialog
        EndSw
      Case WM_CLOSE
        quit_dialog:
        invoke EndDialog,hWin,0
    Endsw

    return 0

hiDlg endp

; 

end start
